<template>
    <div>
        <v-switch small v-model="value" :disabled="disabled" color="primary" hide-details></v-switch>
    </div>
</template>

<script>
    export default {
        data: () => ({
            loading: false
        }),

        props: {
            prop: {
                type: String,
                default: 'status'
            },
            item: {
                type: Object,
                default: {}
            },
            url: {
                type: String
            },
            id: {
                type: [String, Number]
            },
            except: {
                type: Array
            }
        },

        computed: {
            value: {
                get() {
                    return this.item[this.prop];
                },

                set(val) {
                    this.update(val);
                }
            },

            disabled() {
                return this.loading || this.excluded;
            },

            excluded() {
                if (this.except) {
                    return this.except.indexOf(this.id) >= 0;
                }

                return false;
            }
        },

        methods: {
            update(status) {
                if (!this.url) {
                    return false;
                }

                this.loading = true;

                const oldValue = this.item[this.prop];
                this.item[this.prop] = status;

                axios.post(this.url, {id: this.id, status: status})
                    .then(r => {
                        this.loading = false;
                    })
                    .catch(e => {
                        this.loading = false;
                        this.item[this.prop] = oldValue;
                    });
            }
        }
    }
</script>

<style scoped>

</style>
